/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#pragma once
#include "matrices_all.h"
#include "comparator_all.h"

void noise_filter_matrix(Matrices::SuperMatrixPtr pMatrix, size_t mintf, double noisePrec);

void lin_weight_matrix(Matrices::SuperMatrixPtr pMatrix);
void pmi_weight_matrix(Matrices::SuperMatrixPtr pMatrix);
void logent_weight_matrix(Matrices::SuperMatrixPtr pMatrix);
void zscore_weight_matrix(Matrices::SuperMatrixPtr pMatrix);

void rwf_zscore_weight_matrix(Matrices::SuperMatrixPtr pMatrix, double min_rz, const std::string &args);
void rwf_pmi_weight_matrix(Matrices::SuperMatrixPtr pMatrix, double threshold, bool discount, const std::string &args);
void rwf_lin_weight_matrix(Matrices::SuperMatrixPtr pMatrix, double threshold, const std::string &args);


std::vector<std::string> get_kbest(smartcomparator::compare::CompareFunctionPtr pCmp, const std::string &word, int k );
std::vector< std::pair<std::string,double> > get_kbest_val(smartcomparator::compare::CompareFunctionPtr pCmp, const std::string &word, int k );
std::vector< std::pair<std::string, double> > generate_kbest(smartcomparator::compare::CompareFunctionPtr pCmp, const std::string &word, int k );

